-- RCMPGarrison
-- Author: John den Otter (Neirai the Forgiven)
-- DateCreated: 12/17/2013 8:15:28 AM
--------------------------------------------------------------
--------------------------------------------------------------
include("FLuaVector.lua")

local iCanada = GameInfoTypes.CIVILIZATION_COLONIALCANADA

function RCMPGarrisonPower(PlayerID)
	local pPlayer = Players[PlayerID]
	local iHBCTotal = 0
	local iNumFortDummies = 0
	
	if pPlayer and pPlayer:GetCivilizationType() == iCanada then
		local pCapital = pPlayer:GetCapitalCity()
		for uUnit in pPlayer:Units() do
			local mPlot = uUnit:GetPlot()
			local uImprovementOnTile = mPlot:GetImprovementType()

			if mPlot:GetOwner() == PlayerID and (uUnit:IsGarrisoned() or uImprovementOnTile == GameInfoTypes.IMPROVEMENT_CITADEL or uImprovementOnTile == GameInfoTypes.IMPROVEMENT_FORT) then
				if uUnit:IsHasPromotion(GameInfoTypes.PROMOTION_ROYALCANADIANMOUNTIES) then
					iNumFortDummies = iNumFortDummies + 1
				end
				if uUnit:IsHasPromotion(GameInfoTypes.PROMOTION_CLCOLONIALCAPITALISM) then
					iHBCTotal = iHBCTotal + 2
				end
			end
		end
		if pCapital then
			pCapital:SetNumRealBuilding(GameInfoTypes.BUILDING_CANADA_FORT_DUMMY, iNumFortDummies) 	
			if iHBCTotal > 0 then
				pPlayer:ChangeGold(iHBCTotal)
				pPlayer:ChangeJONSCulture(iHBCTotal)
			end
		end
		if pPlayer:IsHuman() and pPlayer:IsTurnActive() and iNumFortDummies > 0 then
			iGoldTotal = ((2*iNumFortDummies)+iHBCTotal)
			pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Our governors' and factors' careful management has increased our wealth and influence:[NEWLINE][ICON_BULLET]+"..iNumFortDummies.." [ICON_GREAT_GENERAL] Great General Points[NEWLINE][ICON_BULLET]+"..iGoldTotal.." [ICON_GOLD] Gold[NEWLINE][ICON_BULLET]+"..iHBCTotal.." [ICON_CULTURE] Culture", "Joint-Stock Company Report", pPlayer:GetCapitalCity():GetX(), pPlayer:GetCapitalCity():GetY())
		end
	end
end

-- 
function RailwayHotelBonus(iPlayer)
	local eRailwayHotel = GameInfoTypes.BUILDING_CANADA_RAILWAY_HOTEL
	local pPlayer = Players[iPlayer]

	if not (pPlayer and pPlayer:GetCivilizationType() == iCanada) then return end

	local iNumberOfRWHotels = pPlayer:CountNumBuildings(eRailwayHotel)
	local pGreatestTileCulture = 0
	
	if iNumberOfRWHotels > 0 then
		local iCurrentRWHotel = 0
		
		--Search for city with highest culture from tiles
		for city1 in pPlayer:Cities() do
			city1:SetNumRealBuilding(GameInfoTypes.BUILDING_D_FOR_RAILWAY_HOTEL, 0)
			
			if (city1:IsHasBuilding(eRailwayHotel) and (city1:IsCapital() or city1:IsConnectedToCapital())) then
				
				local iCultureFromTerrain = city1:GetBaseYieldRateFromTerrain(YieldTypes.YIELD_CULTURE)
				if iCultureFromTerrain > pGreatestTileCulture then
					pGreatestTileCulture = iCultureFromTerrain
				end
			end
		end
		
		--Give all cities Tourism/Gold Dummies equal to 25% of the highest Tile Culture
		for city2 in pPlayer:Cities() do
			if (city2:IsHasBuilding(eRailwayHotel) and (city2:IsCapital() or city2:IsConnectedToCapital())) then
				city2:SetNumRealBuilding(GameInfoTypes.BUILDING_D_FOR_RAILWAY_HOTEL, math.floor(pGreatestTileCulture / 4))
				
				iCurrentRWHotel = iCurrentRWHotel + 1

				if iCurrentRWHotel == iNumberOfRWHotels then
					break
				end
			end
		end
	end
end

-- Caravans claim neutral territory 
function YorkFactoryExpress(iPlayer, iUnit, iX, iY)
	local pPlayer = Players[iPlayer]
	if pPlayer:GetCivilizationType() ~= iCanada then return end

	local pUnit = pPlayer:GetUnitByID(iUnit)
	if (pUnit == nil or pUnit:IsDelayedDeath()) then return end

	if pUnit:GetUnitType() == GameInfoTypes.UNIT_CARAVAN then
		local iRouteIndex = pUnit:GetTradeRouteIndex()
		if iRouteIndex == -1 then return end
				
		if (Game.GetTradeRoute(iRouteIndex).ToCivilizationType == iCanada) then

		local pPlot = pUnit:GetPlot()
			if pPlot and pPlot:GetOwner() == -1 then
				pPlot:SetOwner(iPlayer, pPlayer:GetCapitalCity():GetID(), 1, 1)
--[[
				local pCapital = pPlayer:GetCapitalCity()
				local iEraModifier = math.max(pPlayer:GetCurrentEra(), 1)
				local fGameSpeedModifier = GameInfo.GameSpeeds[ Game.GetGameSpeedType() ].GrowthPercent / 100
				local vUnitPosition = PositionCalculator(pUnit:GetX(), pUnit:GetY())
				--Give yields from policies & beliefs
				if pPlayer:HasPolicy(GameInfoTypes.POLICY_DISCIPLINE) then
					local iEraModifier = math.max(pPlayer:GetCurrentEra(), 1)
					local iChange1 = (15 * iEraModifier * fGameSpeedModifier)
					pCapital:ChangeFood(iChange1)
					pPlayer:ChangeGold(iChange1)
					
					if pPlayer:IsHuman() and pPlayer:IsTurnActive() then
						Events.AddPopupTextEvent(vUnitPosition, "[COLOR_YIELD_FOOD]+"..iChange1.." [ICON_FOOD][ENDCOLOR]", 1)
						Events.AddPopupTextEvent(vUnitPosition, "[COLOR_YIELD_GOLD]+"..iChange1.." [ICON_GOLD][ENDCOLOR]", 1.5)
					end
				end
				
				if pPlayer:HasPolicy(GameInfoTypes.POLICY_HONOR_FINISHER) then
					local iEraModifier = math.max(pPlayer:GetCurrentEra(), 1)
					local iChange1 = (15 * iEraModifier * fGameSpeedModifier)
					pCapital:ChangeFood(iChange1)
					pPlayer:ChangeGold(iChange1)
					
					if pPlayer:IsHuman() and pPlayer:IsTurnActive() then
						Events.AddPopupTextEvent(vUnitPosition, "[COLOR_YIELD_FOOD]+"..iChange1.." [ICON_FOOD][ENDCOLOR]", 1)
						Events.AddPopupTextEvent(vUnitPosition, "[COLOR_YIELD_GOLD]+"..iChange1.." [ICON_GOLD][ENDCOLOR]", 1.5)
					end
				end
				
				if pPlayer:HasPolicy(GameInfoTypes.POLICY_INDUSTRIAL_ESPIONAGE) then
					local iEraModifier = math.max(pPlayer:GetCurrentEra(), 1)
					local iChange2 = (10 * iEraModifier * fGameSpeedModifier)
					pPlayer:ChangeGoldenAgeProgressMeter(iChange2)
					pPlayer:ChangeJONSCulture(iChange2)
					
					if pPlayer:IsHuman() and pPlayer:IsTurnActive() then
						Events.AddPopupTextEvent(vUnitPosition, "[COLOR_MAGENTA]+"..iChange2.." [ICON_CULTURE][ENDCOLOR]", 1)
						Events.AddPopupTextEvent(vUnitPosition, "[COLOR_LIGHT_GREY]+"..iChange2.." [ICON_GOLDEN_AGE][ENDCOLOR]", 2)
					end
				end
				pPlayer:GetBeliefInPantheon()
				if pPlayer:GetBeliefInPantheon() == GameInfoTypes.BELIEF_RELIGIOUS_SETTLEMENTS then
					pCapital:ChangeProduction(10)
					pPlayer:ChangeFaith(20)
					
					if pPlayer:IsHuman() and pPlayer:IsTurnActive() then
						Events.AddPopupTextEvent(vUnitPosition, "[COLOR_WHITE]+20 [ICON_PEACE][ENDCOLOR]", 1)
						Events.AddPopupTextEvent(vUnitPosition, "[COLOR_YIELD_PRODUCTION]+10 [ICON_PRODUCTION][ENDCOLOR]", 1)
					end
				end
				]]--
			end
		end
	end
end

function PositionCalculator(i1, i2)
	return HexToWorld(ToHexFromGrid(Vector2(i1, i2)))
end

if Game.IsCivEverActive(iCanada) then
	GameEvents.PlayerDoTurn.Add(RCMPGarrisonPower)
	GameEvents.PlayerDoTurn.Add(RailwayHotelBonus)
	GameEvents.UnitSetXY.Add(YorkFactoryExpress)
end

