--Canadian Decisions, by Mewr11

--------------------------------------------------------------------------------------------------
--Canada:  Race-free Immigration
--------------------------------------------------------------------------------------------------
print("Loading Canada's Decisions")

local Decisions_CLCanadaRFImmigration = {}
	Decisions_CLCanadaRFImmigration.Name = "Pass a Race-Free Immigration Policy"
	Decisions_CLCanadaRFImmigration.Desc = "We are now emerging into an age when different civilizations will have to learn to live side by side in peaceful interchange, learning from each other, studying each other's history and ideals, art and culture, mutually enriching each other's lives. -- Lester B. Pearson[NEWLINE]Requirement/Restrictions:[NEWLINE][ICON_BULLET]Player must be Canada[NEWLINE][ICON_BULLET]Must have entered the Modern Era[NEWLINE][ICON_BULLET]May only be enacted once per game[NEWLINE]Costs:[NEWLINE][ICON_BULLET]2 [ICON_MAGISTRATES] Magistrates[NEWLINE][ICON_BULLET]500 [ICON_GOLD] Gold[NEWLINE]Rewards:[NEWLINE][ICON_BULLET]+10% [ICON_FOOD] Growth in all cities. You will immediately gain population in your cities from each of your allied city-states."
	HookDecisionCivilizationIcon(Decisions_CLCanadaRFImmigration, "CIVILIZATION_COLONIALCANADA")
	Decisions_CLCanadaRFImmigration.CanFunc = (
		function(pPlayer)
			if pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_COLONIALCANADA then return false, false end
			if load(pPlayer, "Decisions_CLCanadaRFImmigration") == true then
				Decisions_CLCanadaRFImmigration.Desc = Locale.ConvertTextKey("We are now emerging into an age when different civilizations will have to learn to live side by side in peaceful interchange, learning from each other, studying each other's history and ideals, art and culture, mutually enriching each other's lives. -- Lester B. Pearson[NEWLINE]Requirement/Restrictions:[NEWLINE][ICON_BULLET]Player must be Canada[NEWLINE][ICON_BULLET]Must have entered the Modern Era[NEWLINE][ICON_BULLET]May only be enacted once per game[NEWLINE]Costs:[NEWLINE][ICON_BULLET]2 [ICON_MAGISTRATES] Magistrates[NEWLINE][ICON_BULLET]500 [ICON_GOLD] Gold[NEWLINE]Rewards:[NEWLINE][ICON_BULLET]+10% [ICON_FOOD] Growth in all cities. You will immediately gain population in your cities from each of your allied city-states.")
				return false, false, true
			end
			
			local iCost = math.ceil(500 * iMod)
			Decisions_CLCanadaRFImmigration.Desc = Locale.ConvertTextKey("We are now emerging into an age when different civilizations will have to learn to live side by side in peaceful interchange, learning from each other, studying each other's history and ideals, art and culture, mutually enriching each other's lives. -- Lester B. Pearson[NEWLINE]Requirement/Restrictions:[NEWLINE][ICON_BULLET]Player must be Canada[NEWLINE][ICON_BULLET]Must have entered the Modern Era[NEWLINE][ICON_BULLET]May only be enacted once per game[NEWLINE]Costs:[NEWLINE][ICON_BULLET]2 [ICON_MAGISTRATES] Magistrates[NEWLINE][ICON_BULLET]500 [ICON_GOLD] Gold[NEWLINE]Rewards:[NEWLINE][ICON_BULLET]+10% [ICON_FOOD] Growth in all cities. You will immediately gain population in your cities from each of your allied city-states.", iCost)
			if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 2) then return true, false end
			if (pPlayer:GetCurrentEra() >= GameInfo.Eras["ERA_MODERN"].ID and pPlayer:GetGold() >= iCost and pPlayer:GetCapitalCity() ~= nil) then
				return true, true
			else
				return true, false
			end
		end
	)
	
	Decisions_CLCanadaRFImmigration.DoFunc = (
		function(pPlayer)
			local iCost = math.ceil(500 * iMod)
			local iAllyCount = 0
			for i, pCiv in pairs(Players) do
				if (pCiv:IsAlive()) then
					if (pCiv:IsMinorCiv()) then
						if (pCiv:GetMinorCivFriendshipLevelWithMajor(pPlayer:GetID()) == 2) then
							iAllyCount = iAllyCount + 1
						end
					end
				end
			end
			local iPopPerCity = math.floor(iAllyCount / pPlayer:GetNumCities())
			local iPopLeftOver = iAllyCount % pPlayer:GetNumCities()
			
			pPlayer:ChangeNumResourceTotal(iMagistrate, -2)
			pPlayer:ChangeGold(-iCost)
			pPlayer:SetHasPolicy(GameInfoTypes.POLICY_COLONIALCANADA_IMMIGRATION, true)
			for pCity in pPlayer:Cities() do
				pCity:ChangePopulation(iPopPerCity, true)
				if(iPopLeftOver > 0) then
					pCity:ChangePopulation(1, true)
					iPopLeftOver = iPopLeftOver - 1
				end
			end
			
			save(pPlayer, "Decisions_CLCanadaRFImmigration", true)
		end
	)
Decisions_AddCivilisationSpecific(GameInfoTypes["CIVILIZATION_COLONIALCANADA"], "Decisions_CLCanadaRFImmigration", Decisions_CLCanadaRFImmigration)


--------------------------------------------------------------------------------------------------
--Canada:  Canada Health Act
--------------------------------------------------------------------------------------------------

local Decisions_CLCanadaHealthcare = {}
	Decisions_CLCanadaHealthcare.Name = 'Enact the Canada Health Care Act'
	Decisions_CLCanadaHealthcare.Desc = "The government of Canada believes that all Canadians should be able to obtain health services of high quality according to their need for such services and irrespective of their ability to pay. We believe that the only practical and effective way of doing this is through a universal, prepaid, government-sponsored scheme. -- Lester B. Pearson[NEWLINE]Requirement/Restrictions:[NEWLINE][ICON_BULLET]Player must be Canada[NEWLINE][ICON_BULLET]Must have researched Biology[NEWLINE][ICON_BULLET]Must have a Hospital in every city[NEWLINE][ICON_BULLET]May only be enacted once per game[NEWLINE]Costs:[NEWLINE][ICON_BULLET]2 [ICON_MAGISTRATES] Magistrates[NEWLINE][ICON_BULLET]2000 [ICON_GOLD] Gold[NEWLINE]Rewards:[NEWLINE][ICON_BULLET]Hospitals add an additional +2 [ICON_FOOD] Food and +1 [ICON_HAPPINESS_1] Happiness."
	HookDecisionCivilizationIcon(Decisions_CLCanadaHealthcare, "CIVILIZATION_COLONIALCANADA")
	Decisions_CLCanadaHealthcare.CanFunc = (
		function(pPlayer)
			if pPlayer:GetCivilizationType() ~= GameInfoTypes.CIVILIZATION_COLONIALCANADA then return false, false end
			if load(pPlayer, "Decisions_CLCanadaHealthcare") == true then
				Decisions_CLCanadaHealthcare.Desc = Locale.ConvertTextKey("The government of Canada believes that all Canadians should be able to obtain health services of high quality according to their need for such services and irrespective of their ability to pay. We believe that the only practical and effective way of doing this is through a universal, prepaid, government-sponsored scheme. -- Lester B. Pearson[NEWLINE]Rewards:[NEWLINE][ICON_BULLET]Hospitals add an additional +2 [ICON_FOOD] Food and +1 [ICON_HAPPINESS_1] Happiness.")
				return false, false, true
			end
			
			local iCost = math.ceil(2000 * iMod)
			local iHospitalCount = 0
			for pCity in pPlayer:Cities() do
				if pCity:IsHasBuilding(GameInfoTypes.BUILDINGCLASS_HOSPITAL) then
					iHospitalCount = iHospitalCount + 1
				end
			end
			
			if (pPlayer:GetNumResourceAvailable(iMagistrate, false) < 2) then return true, false end
			if (Teams[pPlayer:GetTeam()]:IsHasTech(GameInfoTypes.TECH_BIOLOGY) and pPlayer:GetGold() >= iCost and pPlayer:GetCapitalCity() ~= nil) then
				return true, true
			else
				return true, false
			end
		end
	)
	
	Decisions_CLCanadaHealthcare.DoFunc = (
		function(pPlayer)
			local iCost = math.ceil(2000 * iMod)
			
			pPlayer:ChangeNumResourceTotal(iMagistrate, -2)
			pPlayer:ChangeGold(-iCost)
			pPlayer:SetHasPolicy(GameInfoTypes.POLICY_COLONIALCANADA_HEALTHCARE, true)
			
			save(pPlayer, "Decisions_CLCanadaHealthcare", true)
		end
	)
Decisions_AddCivilisationSpecific(GameInfoTypes.CIVILIZATION_COLONIALCANADA, "Decisions_CLCanadaHealthcare", Decisions_CLCanadaHealthcare)